<template>
  <div class="app-container">
    <el-row type="flex" justify="space-between" ref="listQueryContainer" class="query-container">
      <el-col>
        <el-form :inline="true" style="flex-wrap: wrap" :model="listQuery" ref="listQuery" @submit.native.prevent @keyup.enter.native="onSubmit">
          <el-form-item label="项目名称" prop="itemName">
            <el-input v-model.trim="listQuery.itemName" maxlength="16" placeholder="请输入项目名称" clearable @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="巡检人员" prop="username">
            <el-input v-model.trim="listQuery.username" maxlength="16" placeholder="请输入巡检人员" clearable @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="点编号" prop="pointNo">
            <el-input v-model.trim="listQuery.pointNo" maxlength="16" placeholder="请输入点编号" clearable @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="点名称" prop="pointName">
            <el-input v-model.trim="listQuery.pointName" maxlength="16" placeholder="请输入点名称" clearable @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="点类型" prop="pointType">
            <el-select v-model="listQuery.pointType" placeholder="请选择点类型" clearable @change="onFilterChange">
              <el-option
                  v-for="item in pointTypeList"
                  :key="item.id"
                  :label="item.label"
                  :value="item.id">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="分类目录" prop="patrolTypeId">
            <el-select v-model="listQuery.patrolTypeId" placeholder="请选择分类目录" clearable @change="onFilterChange">
              <el-option v-for="item in classifyList" :key="item.id" :label="item.pointName" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="是否合格" prop="isQualified">
            <el-select v-model="listQuery.isQualified" placeholder="请选择是否合格" clearable @change="onFilterChange">
              <el-option
                  v-for="item in qualifiedList"
                  :key="item.id"
                  :label="item.label"
                  :value="item.id">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="所属计划" prop="planId">
            <el-select v-model="listQuery.planId" placeholder="请选择所属计划" clearable @change="onFilterChange">
              <el-option
                  v-for="item in planList"
                  :key="item.id"
                  :label="item.planName"
                  :value="item.id">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="所属路线" prop="routeId">
            <el-select v-model="listQuery.routeId" placeholder="请选择所属路线" clearable @change="onFilterChange">
              <el-option
                  v-for="item in routeList"
                  :key="item.id"
                  :label="item.routeName"
                  :value="item.id">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="时间范围" prop="dateRange">
            <el-date-picker
                v-model="listQuery.dateRange"
                value-format="yyyy-MM-dd HH:mm:ss"
                type="daterange"
                range-separator="-"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                :default-time="['00:00:00', '23:59:59']"
                @change="onFilterChange">
            </el-date-picker>
          </el-form-item>
          <el-form-item label-width="0">
            <el-button @click="onFilterChange" type="primary">查询</el-button>
            <el-button @click="resetFields" plain type="primary">重置</el-button>
            <el-button @click="onExport" plain type="primary">导出</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <form-clear :shrinkable="shrinkable" @clear="resetFields" @change="onExpansion"/>
    </el-row>
    <el-table :data="list" border stripe highlight-current-row ref="table" class="mt10" @sort-change="onSortChange" @row-click="onRowClick">
      <el-table-column type="index" :index="indexCompute" label="序号" align="center" fixed="left" width="60px"/>
      <el-table-column prop="recordId" label="记录单id" sortable="custom" align="center" fixed="left" width="170px"/>
      <el-table-column prop="itemName" label="项目名称" sortable="custom" align="center" fixed="left" width="170px"/>
      <el-table-column prop="itemType" label="项目类型" sortable="custom" align="center" width="106px">
         <template v-slot="scope">
          {{ itemTypeList.find(item => item.id === Number(scope.row.itemType)).label }}
        </template>
      </el-table-column>
      <el-table-column prop="checkResult" label="检查结果" sortable="custom" align="center" min-width="130px"/>
      <el-table-column prop="isQualified" label="是否合格" sortable="custom" align="center" min-width="130px">
         <template v-slot="scope">
          {{ whetherList.find(item => item.id === Number(scope.row.isQualified)).label }}
        </template>
      </el-table-column>
      <el-table-column prop="isScore" label="评分" sortable="custom" align="center" width="170px"/>
      <el-table-column prop="patrolTime" label="巡检时间" sortable="custom" align="center" width="160px"></el-table-column>
      <el-table-column prop="pointName" label="巡检点" sortable="custom" align="center" min-width="170px"/>
      <el-table-column prop="planName" label="巡检计划" sortable="custom" align="center" width="160px"></el-table-column>
      <el-table-column prop="routeName" label="检查路线" sortable="custom" align="center" width="160px"></el-table-column>
      <el-table-column prop="username" label="巡检人" sortable="custom" align="center" width="160px"></el-table-column>
      <el-table-column label="操作" align="center" width="90px">
         <template v-slot="scope">
          <el-link type="primary" icon="el-icon-view" @click="onDetail(scope.row)">详情</el-link>
        </template>
      </el-table-column>
    </el-table>
    <pagination :total="total" :page.sync="listQuery.page" :size.sync="listQuery.size" @change="onPageChange"/>

    <el-dialog title="导出" :visible.sync="exportVisible" :close-on-click-modal="false" :close-on-press-escape="false" width="600px">
      <el-progress :text-inside="true" :stroke-width="24" :percentage="exportProgress" status="success"></el-progress>
      <el-button slot="footer" @click="onCancelExport">取 消</el-button>
    </el-dialog>

    <dialog-detail v-if="detailDialogVisible" :visible.sync="detailDialogVisible" :data="selectItem"/>
  </div>
</template>

<script>
import FormClear from "@/components/FormClear";
import Pagination from "@/components/Pagination"
import DialogDetail from "./dialogDetail";
import {dateFormat} from "@/utils/dateUtil"
import {toLine} from "@/utils/stringUtil";


export default {
  name: "Situation",
  components: {FormClear, Pagination, DialogDetail},

  data() {

    const defaultStartTime = dateFormat("yyyy-MM-dd 00:00:00", new Date());
    const defaultEndTime = dateFormat("yyyy-MM-dd 23:59:59", new Date());

    return {
      shrinkable: false, // 查询条件是否可以展开
      listQuery: { // 查询对象
        itemName: undefined, // 项目名称
        username: undefined, // 巡检人员名称
        pointNo: undefined, // 点编号
        pointName: undefined, // 点名称
        pointType: undefined, // 点类别 1固定点、2移动点
        patrolTypeId: undefined, // 巡检列表分类id
        isQualified: undefined, // 是否合格 1合格、2不合格
        planId: undefined, // 计划id
        routeId: undefined, // 路线id
        dateRange: [defaultStartTime, defaultEndTime], // 时间范围
        startTime: defaultStartTime,
        endTime: defaultEndTime,
        order: undefined,
        page: 1,
        size: 10
      },

      list: [], // 结果列表
      total: 0, // 总结果数量

      pointTypeList: [{id: 1, label: "固定点"}, {id: 2, label: "移动点"}],
      qualifiedList: [{id: 1, label: "合格"}, {id: 2, label: "不合格"}],
      whetherList: [{id: 1, label: "是"}, {id: 0, label: "否"}],
      itemTypeList: [{id: 1, label: "选择"}, {id: 2, label: "数字"}, {id: 3, label: "文本"}, {id: 4, label: "拍照"}],

      classifyList: [], // 巡检类别列表
      planList: [],
      routeList: [],
      defaultStartTime,
      defaultEndTime,

      exportVisible: false, // 是否显示导出对话框
      exportData: [], // 导出数据
      exportPagination: { // 导出分页
        page: 1,
        size: 500,
      },
      exportProgress: 0, // 导出进度
      exportCancel: false, // 是否取消导出

      detailDialogVisible: false, // 详情对话框是否可见

      selectItem: undefined, // 选中的单条记录
    }
  },

  watch: {
    // 监听日期范围变化
    'listQuery.dateRange'(value) {
      if (value) {
        this.listQuery.startTime = value[0];
        this.listQuery.endTime = value[1];
      } else {
        this.listQuery.startTime = this.defaultStartTime;
        this.listQuery.endTime = this.defaultEndTime;
      }
    }
  },

  // 页面创建
  created() {
    this.initData();
  },

  // 页面挂载
  mounted() {
    this.initQuery();
    this.getList();
    this.initView();
  },

  // keep-alive 显示界面时调用
  activated() {
    this.$refs["table"].doLayout();
  },

  // keep-alive 页面隐藏
  deactivated() {
  },

  methods: {
    // 初始化数据
    initData() {
      this.$axios.get("/v1/check/item/type/list", {params: {size: 100}}, false).then(data => {
        this.classifyList = data.list;
      });
      // this.$axios.get("/check/patrolPlan/list", {params: {size: 999}}).then(data => {
      //   this.planList = data.list;
      // });
      // this.$axios.get("/check/patrolRoute/list", {params: {size: 999}}).then(data => {
      //   this.routeList = data.list;
      // });
    },

    // 初始化查询条件
    initQuery() {
      if (this.$store.state.app.paramCache) {
        let query = this.$storage.getData(this.$options.name);
        if (Object.keys(query).length > 0) {
          this.listQuery = query;
          if (query.order) {
            this.$refs.table.sort(query.order, query.order === "asc" ? "ascending" : "descending");
          } else {
            this.$refs.table.clearSort();
          }
        }
      }
    },

    // 初始化视图
    initView() {
      this.$nextTick(() => {
        this.shrinkable = this.$store.state.app.filterShrink && this.$refs['listQuery'].$el.offsetHeight > 51;
      })
    },

    // 展开/收起查询条件
    onExpansion(show) {
      this.$refs['listQueryContainer'].$el.style.height = show ? "auto" : "51px";
    },

    // 表格索引
    indexCompute(index) {
      return index + 1 + (this.listQuery.page - 1) * this.listQuery.size;
    },

    // 表单提交
    onSubmit() {
      this.onFilterChange();
    },

    // 表单清除
    resetFields() {
      this.$refs['listQuery'].resetFields();
      this.listQuery.order = undefined;
      this.$refs.table.clearSort();
      this.onFilterChange();
    },

    // 详情
    onDetail(item) {
      this.selectItem = item;
      this.detailDialogVisible = true;
    },

    // 排序改变
    onSortChange({prop, order}) {
      if (order === "ascending") {
        this.listQuery.order = "+" + prop;
      } else if (order === "descending") {
        this.listQuery.order = "-" + prop;
      } else {
        this.listQuery.order = undefined;
      }
      this.onFilterChange();
    },

    // 行点击
    onRowClick(row, column, event) {
      this.$refs["table"].setCurrentRow(row);
    },

    // 条件改变
    onFilterChange() {
      this.listQuery.page = 1;
      this.$nextTick(this.getList);
    },

    // 页码改变
    onPageChange() {
      this.getList();
    },

    // 加载列表
    getList() {
      // 缓存参数
      if (this.$store.state.app.paramCache) {
        this.$storage.setData(this.$options.name, this.listQuery);
      }

      // this.$axios.get("/check/patrolRecord/getCheckItemCheckResults", {params: this.listQuery}).then(data => {
      //   this.list = data.list;
      //   this.total = data.total;
      // });
    },

    // 导出数据
    onExport() {
      if (this.total > 0) {
        this.exportPagination.page = 1;
        this.exportData = [];
        this.exportVisible = true;
        // this.getExportData();
      }
    },

    // 取消导出
    onCancelExport() {
      this.exportVisible = false;
      this.exportCancel = true;
    },

    // 获取数据并导出
    getExportData() {
      if (!this.exportCancel) {
        this.$axios.get("/check/patrolRecord/getCheckItemCheckResults", {params: {...this.listQuery, ...this.exportPagination}}).then(data => {
          this.exportPagination.page++;
          this.exportData = this.exportData.concat(data.list);
          this.exportProgress = Math.round(this.exportData.length * 100 / this.total);
          if (this.exportData.length < this.total && data.list.length > 0) {
            this.getExportData();
          } else {
            this.exportVisible = false;

            let tHeader = ["序号",
              "记录单id",
              "项目名称",
              "项目类型",
              "检查结果",
              "是否合格",
              "评分",
              "巡检时间",
              "巡检点",
              "巡检计划",
              "检查路线",
              "巡检人"
            ];
            let filterVal = ["index",
              "recordId",
              "itemName",
              "itemType",
              "checkResult",
              "isQualified",
              "isScore",
              "patrolTime",
              "pointName",
              "planName",
              "routeName",
              "username"
            ];
            let data = this.exportData.map((value, index) => filterVal.map((key) => {
              if (key === "index") {
                return index + 1;
              } else if (key === "itemType") {
                return this.itemTypeList.find(item => item.id === Number(value[key])).label;
              } else if (key === "isQualified") {
                return this.whetherList.find(item => item.id === Number(value[key])).label;
              } else {
                return value[key];
              }
            }));
            import('@/utils/Export2Excel').then(excel => {
              excel.export_json_to_excel({
                header: tHeader, // 表头 必填
                data, // 具体数据 必填
                filename: '检查情况列表', // 非必填
                autoWidth: true, // 非必填
                bookType: 'xlsx' // 非必填
              })
            })
          }
        });
      }
    }
  }
}
</script>

<style scoped lang="scss">
.app-container {

}
</style>
